unit UnitFrmChainWatcher;
{
    Purpose:
        Monitor the clipboard problems caused by other peoples
        f*cked up programs. *sigh*

    Updates:
        I was refreshing the chain wether it needed it or not
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TFrmChainWatcher = class(TForm)
    Timer1: TTimer;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    LastHandle : THandle;
    LastSize : integer;
    DialogShownOnce : boolean;
  public
    { Public declarations }
    procedure NotifyOfClipboardActivity;
  end;

var
  FrmChainWatcher: TFrmChainWatcher;

{////////////////////}
{//}implementation{//}
{////////////////////}

uses Clipbrd, UnitFrmClipboardManager;
{$R *.dfm}

type ByteArray = array of byte;

procedure TFrmChainWatcher.FormCreate(Sender: TObject);
begin
    self.LastHandle := 0;
    self.LastSize := 0;
    DialogShownOnce := false;
end;


procedure TFrmChainWatcher.NotifyOfClipboardActivity;
begin
    // Reset the timer to not trigger until later
    // update: make sure timer does not trigger here
    timer1.Enabled := false;

    if (self.LastHandle <> 0) then begin
        Windows.GlobalFree(self.LastHandle);
    end;
    self.LastHandle := 0;
    self.LastSize := 0;

    timer1.Enabled := true;
end;


//
// I should be shot for this.
// I copied/pasted the code from OtherQueue for duping an item
// form the clipboard
//
procedure TFrmChainWatcher.Timer1Timer(Sender: TObject);
    function DupHandle(h : Thandle; var sizeh : cardinal) : Thandle;
    var
        newh : Thandle;
        p1, p2 : pointer;
    begin
        result := 0;
        if (h = 0) then
            EXIT;

        //
        // make sure size is non-zero
        // and not bigger than size restrictions
        //
        sizeh := Windows.GlobalSize(h);
        if (sizeh = 0) then
            EXIT;

        //
        // Lock and copy
        //

        newh := Windows.GlobalAlloc(GMEM_MOVEABLE, sizeh);
        p1 := Windows.GlobalLock(newh);
        p2 := Windows.GlobalLock(h);

        CopyMemory(p1, p2, sizeh);

        Windows.GlobalUnlock(h);
        Windows.GlobalUnlock(newh);

        result := newh;
    end;

var i : integer;
    h : THandle;

    clipSize : cardinal;
    ClipformatPop : word;
    CliphandlePop : THandle;
    ba1, ba2 : ^ByteArray;
    ChainBroken : boolean;
begin
    ChainBroken := false;

    // find the current format
    // must be non-zero
    ClipformatPop := 0;
    if not Windows.OpenClipboard(Application.Handle) then
        EXIT;

    for i := 0 to clipboard.FormatCount - 1 do begin
        if (clipboard.HasFormat(Clipboard.Formats[i])) then begin
            ClipFormatPop := Clipboard.Formats[i];
        end;
    end;

    if (ClipFormatPop  = 0) then begin
        Windows.CloseClipboard;
        EXIT;
    end;


    //
    // Dupe the handle, exit on error
    // (aka copy what's on the clipboard)

    h := clipboard.GetAsHandle(ClipFormatPop);
    CliphandlePop := DupHandle(h, ClipSize);
    Windows.CloseClipboard;
    if (CliphandlePop = 0) then
        EXIT;

    // First time here?
    if (self.LastHandle = 0) then begin
        LastHandle := CliphandlePop;
        LastSize := ClipSize;
    end else begin
        if (LastSize <> ClipSize) then begin
            // size must be equal or we know a break has happened
            ChainBroken := true;
        end else begin
            // compare the contents of each memory location
            // becuase the size is the same
            ba1 := Pointer(LastHandle);
            ba2 := Pointer(ClipHandlePop);

            for i := 0 to ClipSize - 1 do begin
                if (ba1^[i] <> ba2^[i]) then begin
                    ChainBroken := true;
                    BREAK;
                end;
            end;
        end;


        // Fix the chain and/or Warn about it
        // GRR - bad bad bad me
        // I was refreshing the chain wether it needed it or not

        if (ChainBroken) then begin
            if (not DialogShownOnce) then begin
                Windows.SetForegroundWindow(self.handle);
                Dialogs.ShowMessage(
                    'ERROR: The Clipboard chain has been broken.' + #13#10 +
                    'Please note which programs are running that may have caused this problem.' + #13#10 +
                    #13#10 +
                    'The Clipboard Monitor will automatically be refreshed and this message'+#13#10+
                    'will not be shown again this session.');
                DialogShownOnce := true;
            end;
            
            FrmClipboardManager.RefreshClipboardMonitor;
        end;

        // clean up the previous copy
        // store for next time this event fires

        Windows.GlobalFree(LastHandle);

        LastHandle := CliphandlePop;
        LastSize := ClipSize;

    end;
end;




end.
