unit UnitFrmRemoved;

{
    Purpose:
        User interface to copy a removed item to the clipboard

    Updates:

    NOTES: I'm using the same dirty trick to work-around Win9x control
    memory limitations as I used in FrmClipboardManager.
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TFrmRemoved = class(TForm)
    lbList: TListBox;
    bCopy: TButton;
    bClose: TButton;
    Label1: TLabel;
    mPreview: TMemo;
    bFlushItems: TButton;
    procedure FormShow(Sender: TObject);
    procedure lbListClick(Sender: TObject);
    procedure bCopyClick(Sender: TObject);
    procedure bCloseClick(Sender: TObject);
    procedure bFlushItemsClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmRemoved: TFrmRemoved;

implementation

{$R *.dfm}

Uses UnitClipQueue, StrUtils, Clipbrd;

procedure TFrmRemoved.FormShow(Sender: TObject);
var i : longint;
begin
    bCopy.Enabled := false;

    lbList.Items.BeginUpdate;
    lbList.Items.Clear;

    for i := 0 to (RemovedQueue.GetQueueCount - 1) do begin
        lbList.Items.AddObject(LeftStr(RemovedQueue.GetQueueItem(i),160),
            TObject(PChar(RemovedQueue.GetQueueItem(i))));
    end;

    lbList.Items.EndUpdate;
end;

procedure TFrmRemoved.lbListClick(Sender: TObject);
begin
    bCopy.Enabled := true;
    mPreview.Text := Leftstr(PChar(lbList.Items.Objects[lbList.itemindex]), 10000);
end;

procedure TFrmRemoved.bCopyClick(Sender: TObject);
begin
    Clipboard.SetTextBuf( PChar(lbList.Items.Objects[lbList.itemindex]) );
    self.hide;
end;

procedure TFrmRemoved.bCloseClick(Sender: TObject);
begin
    self.Hide;
end;

procedure TFrmRemoved.bFlushItemsClick(Sender: TObject);
begin
    lbList.items.clear;
end;

end.


